Package icyllis.arc3d.opengl

# Class GLImage

java.lang.Object
icyllis.arc3d.engine.Resource
icyllis.arc3d.engine.Image
icyllis.arc3d.opengl.GLImage

All Implemented Interfaces:
  `RefCounted`

Direct Known Subclasses:
  `GLRenderbuffer`, `GLTexture`

public abstract sealed class GLImage extends Image permits GLTexture, GLRenderbuffer
Represents OpenGL textures and renderbuffers.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `GLImage.ResourceKey`

- ## Field Summary

  ### Fields inherited from class icyllis.arc3d.engine.Image

  `mFlags`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `GLImage(Context context, boolean budgeted, boolean wrapped, GLImageDesc desc, ImageMutableState mutableState)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected GLDevice`
  `getDevice()`
  `int`
  `getFormat()`
  `final GLImageDesc`
  `getGLDesc()`
  `abstract int`
  `getHandle()`
  `int`
  `getTarget()`

  ### Methods inherited from class icyllis.arc3d.engine.Image

  `getArraySize, getDepth, getDepthBits, getDesc, getHeight, getImageType, getMipLevelCount, getMutableState, getSampleCount, getStencilBits, getWidth, isMipmapped, isMipmapsDirty, isProtected, isReadOnly, isRenderable, isSampledImage, isStorageImage, onRelease, setMipmapsDirty, setReleaseCallback`

  ### Methods inherited from class icyllis.arc3d.engine.Resource

  `getContext, getKey, getLabel, getMemorySize, getUniqueID, hasAnyRefs, hasCacheRef, hasCommandBufferRef, hasUsageRef, isBudgeted, isDestroyed, isPurgeable, isWrapped, onSetLabel, ref, refCommandBuffer, setKey, setLabel, setNonCacheable, unref, unrefCommandBuffer`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### GLImage

    protected GLImage(Context context, boolean budgeted, boolean wrapped, GLImageDesc desc, ImageMutableState mutableState)

- ## Method Details

  - ### getGLDesc

    @Nonnull public final GLImageDesc getGLDesc()

  - ### getDevice

    protected GLDevice getDevice()
    Overrides:
      `getDevice` in class `Resource`
    Returns:
      the device or null if destroyed

  - ### getTarget

    public int getTarget()

  - ### getFormat

    public int getFormat()

  - ### getHandle

    public abstract int getHandle()